diff --git a/src/backend/commands/ddldeparse.c b/src/backend/commands/ddldeparse.c
index 5878d7e465..7165ead751 100644
--- a/src/backend/commands/ddldeparse.c
+++ b/src/backend/commands/ddldeparse.c
@@ -1852,41 +1647,67 @@ deparse_CreateStmt(Oid objectId, Node *parsetree)
 		 */
 		if (node->ofTypename)
 		{
-			tmp_obj = new_objtree_for_type(relation->rd_rel->reloftype, -1);
-			append_object_object(ret, "OF %{of_type}T", tmp_obj);
+			appendStringInfoString(&fmtStr, " OF %{of_type}T");
+
+			/* Push the key first */
+			insert_jsonb_key(state, "of_type");
+
+			/* Push the value */
+			new_jsonb_for_type(state, relation->rd_rel->reloftype, -1);
 		}
 		else
 		{
 			List	   *parents;
-			ObjElem    *elem;
+			Oid			objid;
 
-			parents = deparse_InhRelations(objectId);
-			elem = (ObjElem *) linitial(parents);
+			appendStringInfoString(&fmtStr, " PARTITION OF %{parent_identity}D");
 
-			Assert(list_length(parents) == 1);
+			parents = deparse_InhRels_ToJsonb(objectId);
+			objid = linitial_oid(parents);
 
-			append_format_string(ret, "PARTITION OF");
+			Assert(list_length(parents) == 1);
 
-			append_object_object(ret, "%{parent_identity}D",
-								 elem->value.object);
+			new_jsonb_for_qualname_id(state, RelationRelationId,
+									  objid, "parent_identity", false);
 		}
 
-		tableelts = deparse_TableElements(relation, node->tableElts, dpcontext,
-										  true, /* typed table */
-										  false);	/* not composite */
-		tableelts = obtainConstraints(tableelts, objectId);
+		telems = table_elem_present_col(relation, node->tableElts, true);
+		if (!telems)
+			telems = table_elem_present_const(objectId);
 
-		tmp_obj = new_objtree("");
-		if (tableelts)
-			append_array_object(tmp_obj, "(%{elements:, }s)", tableelts);
-		else
-			append_not_present(tmp_obj, "(%{elements:, }s)");
+		appendStringInfoString(&fmtStr, " %{table_elements}s");
+
+		if (telems)
+		{
+			insert_jsonb_key(state, "table_elements");
+			pushJsonbValue(&state, WJB_BEGIN_OBJECT, NULL);
+
+			fmt_to_jsonb_element(state, "(%{elements:, }s)");
+
+			insert_jsonb_key(state, "elements");
+			pushJsonbValue(&state, WJB_BEGIN_ARRAY, NULL);
 
-		append_object_object(ret, "%{table_elements}s", tmp_obj);
+			deparse_TableElems_ToJsonb(state, relation, node->tableElts, dpcontext,
+									   true,	/* typed table */
+									   false);	/* not composite */
+
+			deparse_Constraints_ToJsonb(state, objectId);
+
+			/* end of elements array */
+			pushJsonbValue(&state, WJB_END_ARRAY, NULL);
+
+			/* end of table_elements object */
+			pushJsonbValue(&state, WJB_END_OBJECT, NULL);
+		}
+		else
+		{
+			insert_jsonb_key(state, "table_elements");
+			insert_not_present_obj(state, "(%{elements:, }s)");
+		}
 	}
 	else
 	{
-		List	   *tableelts = NIL;
+		List	   *inhrelations;
 
 		/*
 		 * There is no need to process LIKE clauses separately; they have
@@ -1899,15 +1720,34 @@ deparse_CreateStmt(Oid objectId, Node *parsetree)
 		 * get constraints we rely on pg_constraint, because the parse node
 		 * might be missing some things such as the name of the constraints.
 		 */
-		tableelts = deparse_TableElements(relation, node->tableElts, dpcontext,
-										  false,	/* not typed table */
-										  false);	/* not composite */
-		tableelts = obtainConstraints(tableelts, objectId);
+		telems = table_elem_present_col(relation, node->tableElts, false);
+		if (!telems)
+			telems = table_elem_present_const(objectId);
+
+		if (telems)
+		{
+			appendStringInfoString(&fmtStr, " (%{table_elements:, }s)");
+			insert_jsonb_key(state, "table_elements");
+
+			/*
+			 * It will be of array type for multi-columns table, so lets begin
+			 * an arrayobject. deparse_TableElems_ToJsonb() will add elements
+			 * to it.
+			 */
+			pushJsonbValue(&state, WJB_BEGIN_ARRAY, NULL);
 
-		if (tableelts)
-			append_array_object(ret, "(%{table_elements:, }s)", tableelts);
+			deparse_TableElems_ToJsonb(state, relation, node->tableElts, dpcontext,
+									   false,	/* not typed table */
+									   false);	/* not composite */
+			deparse_Constraints_ToJsonb(state, objectId);
+
+			pushJsonbValue(&state, WJB_END_ARRAY, NULL);
+		}
 		else
-			append_format_string(ret, "()");
+			appendStringInfoString(&fmtStr, " ()");
+
+		appendStringInfoString(&fmtStr, " %{inherits}s");
+		insert_jsonb_key(state, "inherits");
 
 		/*
 		 * Add inheritance specification.  We cannot simply scan the list of
@@ -1916,82 +1756,88 @@ deparse_CreateStmt(Oid objectId, Node *parsetree)
 		 * re-resolve them from the information in the parse node, it seems
 		 * more accurate and convenient to grab it from pg_inherits.
 		 */
-		tmp_obj = new_objtree("INHERITS");
 		if (node->inhRelations != NIL)
-			append_array_object(tmp_obj, "(%{parents:, }D)",
-								deparse_InhRelations(objectId));
-		else
-			append_not_present(tmp_obj, "(%{parents:, }D)");
+		{
+			pushJsonbValue(&state, WJB_BEGIN_OBJECT, NULL);
+
+			fmt_to_jsonb_element(state, "INHERITS (%{parents:, }D)");
+			inhrelations = deparse_InhRels_ToJsonb(objectId);
 
-		append_object_object(ret, "%{inherits}s", tmp_obj);
+			new_jsonbArray_for_qualname_id(state, "parents", inhrelations);
+			pushJsonbValue(&state, WJB_END_OBJECT, NULL);
+		}
+		else
+			insert_not_present_obj(state, verbose ? "INHERITS (%{parents:, }D)" : "INHERITS");
 	}
 
+
 	/* FOR VALUES clause */
 	if (node->partbound)
 	{
+		appendStringInfoString(&fmtStr, " %{partition_bound}s");
+
 		/*
 		 * Get pg_class.relpartbound. We cannot use partbound in the parsetree
 		 * directly as it's the original partbound expression which haven't
 		 * been transformed.
 		 */
-		append_string_object(ret, "%{partition_bound}s", "partition_bound",
-							 RelationGetPartitionBound(objectId));
+		new_jsonb_VA(state, NULL, true, 1,
+					 "partition_bound", jbvString, RelationGetPartitionBound(objectId));
 	}
 
 	/* PARTITION BY clause */
-	tmp_obj = new_objtree("PARTITION BY");
+	appendStringInfoString(&fmtStr, " %{partition_by}s");
+	insert_jsonb_key(state, "partition_by");
+
 	if (relation->rd_rel->relkind == RELKIND_PARTITIONED_TABLE)
-		append_string_object(tmp_obj, "%{definition}s", "definition",
-							 pg_get_partkeydef_string(objectId));
+		new_jsonb_VA(state, "PARTITION BY %{definition}s", false, 1,
+					 "definition", jbvString, pg_get_partkeydef_string(objectId));
 	else
-		append_not_present(tmp_obj, "%{definition}s");
+		insert_not_present_obj(state, verbose ? "PARTITION BY %{definition}s" : "PARTITION BY");
 
-	append_object_object(ret, "%{partition_by}s", tmp_obj);
 
 	/* USING clause */
-	tmp_obj = new_objtree("USING");
+	appendStringInfoString(&fmtStr, " %{access_method}s");
+	insert_jsonb_key(state, "access_method");
+
 	if (node->accessMethod)
-		append_string_object(tmp_obj, "%{access_method}I", "access_method",
-							 node->accessMethod);
+		new_jsonb_VA(state, "USING %{access_method}I", false, 1,
+					 "access_method", jbvString, node->accessMethod);
 	else
-		append_not_present(tmp_obj, "%{access_method}I");
-
-	append_object_object(ret, "%{access_method}s", tmp_obj);
+		insert_not_present_obj(state, verbose ? "USING %{access_method}I" : "USING");
 
 	/* WITH clause */
-	tmp_obj = new_objtree("WITH");
-
-	foreach(cell, node->options)
-	{
-		ObjTree    *tmp_obj2;
-		DefElem    *opt = (DefElem *) lfirst(cell);
-
-		tmp_obj2 = deparse_DefElem(opt, false);
-		list = lappend(list, new_object_object(tmp_obj2));
-	}
+	appendStringInfoString(&fmtStr, " %{with_clause}s");
+	insert_jsonb_key(state, "with_clause");
 
-	if (list)
-		append_array_object(tmp_obj, "(%{with:, }s)", list);
+	if (node->options)
+		deparse_withObj_ToJsonb(state, "WITH (%{with:, }s)", node);
 	else
-		append_not_present(tmp_obj, "(%{with:, }s)");
-
-	append_object_object(ret, "%{with_clause}s", tmp_obj);
+		insert_not_present_obj(state, verbose ? "WITH (%{with:, }s)" : "WITH");
 
-	append_object_object(ret, "%{on_commit}s",
-						 deparse_OnCommitClause(node->oncommit));
+	/* TABLESPACE */
+	appendStringInfoString(&fmtStr, " %{tablespace}s");
+	insert_jsonb_key(state, "tablespace");
 
-	tmp_obj = new_objtree("TABLESPACE");
+	/* Push the value now: object in this case */
 	if (node->tablespacename)
-		append_string_object(tmp_obj, "%{tablespace}I", "tablespace",
-							 node->tablespacename);
+		new_jsonb_VA(state, "TABLESPACE %{tablespace}I", false, 1,
+					 "tablespace", jbvString, node->tablespacename);
 	else
-		append_not_present(tmp_obj, "%{tablespace}I");
+		insert_not_present_obj(state, verbose ? "TABLESPACE %{tablespace}I" : "TABLESPACE");
 
-	append_object_object(ret, "%{tablespace}s", tmp_obj);
 
 	relation_close(relation, AccessShareLock);
 
-	return ret;
+	/* We have full fmt by now, so add jsonb element for that */
+	fmt_to_jsonb_element(state, fmtStr.data);
+
+	pfree(fmtStr.data);
+
+	/* Mark the end of ROOT object */
+	value = pushJsonbValue(&state, WJB_END_OBJECT, NULL);
+
+	return JsonbValueToJsonb(value);
 }
 
 /*
@@ -2000,41 +1846,97 @@ deparse_CreateStmt(Oid objectId, Node *parsetree)
  * deparse_CreateStmt do the actual work as we deparse the final CreateStmt for
  * CREATE TABLE AS command.
  */
-static ObjTree *
-deparse_CreateTableAsStmt(CollectedCommand *cmd)
+static Jsonb *
+deparse_CreateTableAsStmt(CollectedCommand *cmd, ddl_deparse_context * context)
 {
 	Oid			objectId;
 	Node	   *parsetree;
+	char	   *owner = context->include_owner ? cmd->role : NULL;
 
 	Assert(cmd->type == SCT_CreateTableAs);
 
 	parsetree = cmd->d.ctas.real_create;
 	objectId = cmd->d.ctas.address.objectId;
+	return deparse_CreateStmt(objectId, parsetree, owner);
+}
+
+/*
+ * Deparse a DropStmt (DROP TABLE).
+ *
+ * Given an object identity and the parse tree that created it, return
+ * jsonb string representing the drop command.
+ *
+ * Verbose syntax
+ * DROP %{objtype}s %{concurrently}s %{if_exists}s %{objidentity}s %{cascade}s
+ */
+char *
+deparse_drop_table(const char *objidentity, const char *objecttype,
+				   Node *parsetree)
+{
+	DropStmt   *node = (DropStmt *) parsetree;
+	StringInfoData fmtStr;
+	char	   *identity = (char *) objidentity;
+	JsonbValue *jsonbval;
+	Jsonb	   *jsonb;
+	StringInfoData str;
+	JsonbParseState *state = NULL;
+
+	initStringInfo(&str);
+	initStringInfo(&fmtStr);
+
+	/* Start constructing fmt string */
+	appendStringInfoString(&fmtStr, "DROP %{objtype}s %{concurrently}s %{if_exists}s %{objidentity}s");
+
+	pushJsonbValue(&state, WJB_BEGIN_OBJECT, NULL);
+
+
+	new_jsonb_VA(state, NULL, true, 4,
+				 "objtype", jbvString, objecttype,
+				 "concurrently", jbvString, node->concurrent ? "CONCURRENTLY" : "",
+				 "if_exists", jbvString, node->missing_ok ? "IF EXISTS" : "",
+				 "objidentity", jbvString, identity);
 
-	return deparse_CreateStmt(objectId, parsetree);
+	if (node->behavior == DROP_CASCADE)
+	{
+		appendStringInfoString(&fmtStr, " %{cascade}s");
+		insert_jsonb_key(state, "cascade");
+
+		pushJsonbValue(&state, WJB_BEGIN_OBJECT, NULL);
+		fmt_to_jsonb_element(state, "CASCADE");
+		pushJsonbValue(&state, WJB_END_OBJECT, NULL);
+	}
+
+	/* We have full fmt by now, so add jsonb element for that */
+	fmt_to_jsonb_element(state, fmtStr.data);
+	pfree(fmtStr.data);
+
+	jsonbval = pushJsonbValue(&state, WJB_END_OBJECT, NULL);
+
+	jsonb = JsonbValueToJsonb(jsonbval);
+	return JsonbToCString(&str, &jsonb->root, JSONB_ESTIMATED_LEN);
 }
 
 /*
- * Deparse all the collected subcommands and return an ObjTree representing the
- * alter command.
+ * Deparse all the collected subcommands and return jsonb string representing
+ * the alter command.
  *
  * Verbose syntax
  * ALTER %{objtype}s %{only}s %{identity}D %{subcmds:, }s
  */
-static ObjTree *
-deparse_AlterRelation(CollectedCommand *cmd, ddl_deparse_context *context)
+static Jsonb *
+deparse_AlterTableStmt(CollectedCommand *cmd, ddl_deparse_context * context)
 {
-	ObjTree    *ret;
-	ObjTree    *tmp_obj;
-	ObjTree    *tmp_obj2;
 	List	   *dpcontext;
 	Relation	rel;
-	List	   *subcmds = NIL;
 	ListCell   *cell;
 	const char *reltype;
 	Node	   *expr = NULL;
 	Oid			relId = cmd->d.alterTable.objectId;
 	AlterTableStmt *stmt = NULL;
+	StringInfoData fmtStr;
+	JsonbParseState *state = NULL;
+	bool		subCmdArray = false;
+	JsonbValue *value;
 
 	Assert(cmd->type == SCT_AlterTable);
 	stmt = (AlterTableStmt *) cmd->parsetree;
@@ -2069,53 +1971,70 @@ deparse_AlterRelation(CollectedCommand *cmd, ddl_deparse_context *context)
 			elog(ERROR, "unexpected relkind %d", rel->rd_rel->relkind);
 	}
 
-	dpcontext = deparse_context_for(RelationGetRelationName(rel),
-									relId);
 
-	ret = new_objtree_VA("ALTER %{objtype}s %{only}s %{identity}D", 3,
-						 "objtype", ObjTypeString, reltype,
-						 "only", ObjTypeString,
-						 stmt->relation->inh ? "" : "ONLY",
-						 "identity", ObjTypeObject,
-						 new_objtree_for_qualname(rel->rd_rel->relnamespace,
-												  RelationGetRelationName(rel)));
+	dpcontext = deparse_context_for(RelationGetRelationName(rel), relId);
+
+	initStringInfo(&fmtStr);
+
+	/* Start constructing fmt string */
+	appendStringInfoString(&fmtStr, "ALTER %{objtype}s %{only}s %{identity}D ");
+
+	pushJsonbValue(&state, WJB_BEGIN_OBJECT, NULL);
+
+	new_jsonb_VA(state, NULL, true, 2,
+				 "objtype", jbvString, reltype,
+				 "only", jbvString, stmt->relation->inh ? "" : "ONLY");
+
+	insert_identity_object(state, rel->rd_rel->relnamespace,
+						   RelationGetRelationName(rel));
 
 	foreach(cell, cmd->d.alterTable.subcmds)
 	{
 		CollectedATSubcmd *sub = (CollectedATSubcmd *) lfirst(cell);
 		AlterTableCmd *subcmd = (AlterTableCmd *) sub->parsetree;
-		ObjTree    *tree;
 
 		Assert(IsA(subcmd, AlterTableCmd));
 
-	   /*
-		* Skip deparse of the subcommand if the objectId doesn't match the
-		* target relation ID. It can happen for inherited tables when
-		* subcommands for inherited tables and the parent table are both
-		* collected in the ALTER TABLE command for the parent table.
-		*/
+		/*
+		 * Skip deparse of the subcommand if the objectId doesn't match the
+		 * target relation ID. It can happen for inherited tables when
+		 * subcommands for inherited tables and the parent table are both
+		 * collected in the ALTER TABLE command for the parent table.
+		 */
 		if (subcmd->subtype != AT_AttachPartition &&
 			sub->address.objectId != relId &&
 			has_superclass(sub->address.objectId))
 			continue;
 
+		if (!subCmdArray)
+		{
+			insert_jsonb_key(state, "subcmds");
+			pushJsonbValue(&state, WJB_BEGIN_ARRAY, NULL);
+			subCmdArray = true;
+		}
+
 		switch (subcmd->subtype)
 		{
 			case AT_AddColumn:
 				/* XXX need to set the "recurse" bit somewhere? */
 				Assert(IsA(subcmd->def, ColumnDef));
-				tree = deparse_ColumnDef(rel, dpcontext, false,
-										 (ColumnDef *) subcmd->def, true, &expr);
 
 				mark_function_volatile(context, expr);
 
-				tmp_obj = new_objtree_VA("ADD %{objtype}s %{if_not_exists}s %{definition}s", 4,
-										"objtype", ObjTypeString, "COLUMN",
-										"type", ObjTypeString, "add column",
-										"if_not_exists", ObjTypeString,
-										subcmd->missing_ok ? "IF NOT EXISTS" : "",
-										"definition", ObjTypeObject, tree);
-				subcmds = lappend(subcmds, new_object_object(tmp_obj));
+				pushJsonbValue(&state, WJB_BEGIN_OBJECT, NULL);
+				new_jsonb_VA(state,
+							 "ADD %{objtype}s %{if_not_exists}s %{definition}s", true, 3,
+							 "objtype", jbvString, "COLUMN",
+							 "type", jbvString, "add column",
+							 "if_not_exists", jbvString,
+							 subcmd->missing_ok ? "IF NOT EXISTS" : "");
+
+				/* Push definition key-value pair */
+				insert_jsonb_key(state, "definition");
+				deparse_ColumnDef_toJsonb(state, rel, dpcontext,
+										  false, (ColumnDef *) subcmd->def,
+										  true, NULL);
+				pushJsonbValue(&state, WJB_END_OBJECT, NULL);
 				break;
 
 			case AT_AddIndexConstraint:
@@ -2137,24 +2056,21 @@ deparse_AlterRelation(CollectedCommand *cmd, ddl_deparse_context *context)
 					 * ADD CONSTRAINT %{name}I %{constraint_type}s USING INDEX
 					 * %index_name}I %{deferrable}s %{init_deferred}s
 					 */
-					tmp_obj = new_objtree_VA("ADD CONSTRAINT %{name}I %{constraint_type}s USING INDEX %{index_name}I %{deferrable}s %{init_deferred}s", 6,
-											"type", ObjTypeString, "add constraint using index",
-											"name", ObjTypeString, get_constraint_name(constrOid),
-											"constraint_type", ObjTypeString,
-											istmt->primary ? "PRIMARY KEY" : "UNIQUE",
-											"index_name", ObjTypeString,
-											RelationGetRelationName(idx),
-											"deferrable", ObjTypeString,
-											istmt->deferrable ? "DEFERRABLE" : "NOT DEFERRABLE",
-											"init_deferred", ObjTypeString,
-											istmt->initdeferred ? "INITIALLY DEFERRED" : "INITIALLY IMMEDIATE");
-
-					subcmds = lappend(subcmds, new_object_object(tmp_obj));
-
+					new_jsonb_VA(state,
+								 "ADD CONSTRAINT %{name}I %{constraint_type}s USING INDEX %{index_name}I %{deferrable}s %{init_deferred}s", false, 6,
+								 "type", jbvString, "add constraint using index",
+								 "name", jbvString, get_constraint_name(constrOid),
+								 "constraint_type", jbvString,
+								 istmt->primary ? "PRIMARY KEY" : "UNIQUE",
+								 "index_name", jbvString,
+								 RelationGetRelationName(idx),
+								 "deferrable", jbvString,
+								 istmt->deferrable ? "DEFERRABLE" : "NOT DEFERRABLE",
+								 "init_deferred", jbvString,
+								 istmt->initdeferred ? "INITIALLY DEFERRED" : "INITIALLY IMMEDIATE");
 					relation_close(idx, AccessShareLock);
+					break;
 				}
-				break;
-
 			case AT_ReAddIndex:
 			case AT_ReAddConstraint:
 			case AT_ReAddDomainConstraint:
@@ -2199,124 +2115,130 @@ deparse_AlterRelation(CollectedCommand *cmd, ddl_deparse_context *context)
 
 			case AT_ColumnDefault:
 				if (subcmd->def == NULL)
-					tmp_obj = new_objtree_VA("ALTER COLUMN %{column}I DROP DEFAULT", 2,
-											"type", ObjTypeString, "drop default",
-											"column", ObjTypeString, subcmd->name);
+					new_jsonb_VA(state,
+								 "ALTER COLUMN %{column}I DROP DEFAULT", false, 2,
+								 "type", jbvString, "drop default",
+								 "column", jbvString, subcmd->name);
 				else
 				{
 					List	   *dpcontext_rel;
 					HeapTuple	attrtup;
 					AttrNumber	attno;
 
-					tmp_obj = new_objtree_VA("ALTER COLUMN %{column}I SET DEFAULT", 2,
-											"type", ObjTypeString, "set default",
-											"column", ObjTypeString, subcmd->name);
-
 					dpcontext_rel = deparse_context_for(RelationGetRelationName(rel),
 														RelationGetRelid(rel));
 					attrtup = SearchSysCacheAttName(RelationGetRelid(rel), subcmd->name);
 					attno = ((Form_pg_attribute) GETSTRUCT(attrtup))->attnum;
-					append_string_object(tmp_obj, "%{definition}s", "definition",
-										 RelationGetColumnDefault(rel, attno,
-																  dpcontext_rel,
-																  NULL));
+
+					new_jsonb_VA(state,
+								 "ALTER COLUMN %{column}I SET DEFAULT %{definition}s", false, 3,
+								 "type", jbvString, "set default",
+								 "column", jbvString, subcmd->name,
+								 "definition", jbvString,
+								 RelationGetColumnDefault(rel, attno,
+														  dpcontext_rel,
+														  NULL));
 					ReleaseSysCache(attrtup);
 				}
 
-				subcmds = lappend(subcmds, new_object_object(tmp_obj));
 				break;
 
 			case AT_DropNotNull:
-				tmp_obj = new_objtree_VA("ALTER COLUMN %{column}I DROP NOT NULL", 2,
-										"type", ObjTypeString, "drop not null",
-										"column", ObjTypeString, subcmd->name);
-				subcmds = lappend(subcmds, new_object_object(tmp_obj));
+				new_jsonb_VA(state,
+							 "ALTER COLUMN %{column}I DROP NOT NULL", false, 2,
+							 "type", jbvString, "drop not null",
+							 "column", jbvString, subcmd->name);
 				break;
 
 			case AT_ForceRowSecurity:
-				tmp_obj = new_objtree("FORCE ROW LEVEL SECURITY");
-				subcmds = lappend(subcmds, new_object_object(tmp_obj));
+				new_jsonb_VA(state, "FORCE ROW LEVEL SECURITY", false, 0);
 				break;
 
 			case AT_NoForceRowSecurity:
-				tmp_obj = new_objtree("NO FORCE ROW LEVEL SECURITY");
-				subcmds = lappend(subcmds, new_object_object(tmp_obj));
+				new_jsonb_VA(state, "NO FORCE ROW LEVEL SECURITY", false, 0);
 				break;
 
 			case AT_SetNotNull:
-				tmp_obj = new_objtree_VA("ALTER COLUMN %{column}I SET NOT NULL", 2,
-										"type", ObjTypeString, "set not null",
-										"column", ObjTypeString, subcmd->name);
-				subcmds = lappend(subcmds, new_object_object(tmp_obj));
+				new_jsonb_VA(state,
+							 "ALTER COLUMN %{column}I SET NOT NULL", false, 2,
+							 "type", jbvString, "set not null",
+							 "column", jbvString, subcmd->name);
 				break;
 
 			case AT_DropExpression:
-				tmp_obj = new_objtree_VA("ALTER COLUMN %{column}I DROP EXPRESSION %{if_exists}s", 3,
-										"type", ObjTypeString, "drop expression",
-										"column", ObjTypeString, subcmd->name,
-										"if_exists", ObjTypeString,
-										subcmd->missing_ok ? "IF EXISTS" : "");
-				subcmds = lappend(subcmds, new_object_object(tmp_obj));
+				new_jsonb_VA(state,
+							 "ALTER COLUMN %{column}I DROP EXPRESSION %{if_exists}s", false, 3,
+							 "type", jbvString, "drop expression",
+							 "column", jbvString, subcmd->name,
+							 "if_exists", jbvString,
+							 subcmd->missing_ok ? "IF EXISTS" : "");
 				break;
 
 			case AT_SetStatistics:
 				{
 					Assert(IsA(subcmd->def, Integer));
 					if (subcmd->name)
-						tmp_obj = new_objtree_VA("ALTER COLUMN %{column}I SET STATISTICS %{statistics}n", 3,
-												"type", ObjTypeString, "set statistics",
-												"column", ObjTypeString, subcmd->name,
-												"statistics", ObjTypeInteger,
-												intVal((Integer *) subcmd->def));
+						new_jsonb_VA(state,
+									 "ALTER COLUMN %{column}I SET STATISTICS %{statistics}n", false, 3,
+									 "type", jbvString, "set statistics",
+									 "column", jbvString, subcmd->name,
+									 "statistics", jbvNumeric,
+									 intVal((Integer *) subcmd->def));
 					else
-						tmp_obj = new_objtree_VA("ALTER COLUMN %{column}n SET STATISTICS %{statistics}n", 3,
-												"type", ObjTypeString, "set statistics",
-												"column", ObjTypeInteger, subcmd->num,
-												"statistics", ObjTypeInteger,
-												intVal((Integer *) subcmd->def));
-					subcmds = lappend(subcmds, new_object_object(tmp_obj));
+						new_jsonb_VA(state,
+									 "ALTER COLUMN %{column}I SET STATISTICS %{statistics}n", false, 3,
+									 "type", jbvString, "set statistics",
+									 "column", jbvNumeric, subcmd->num,
+									 "statistics", jbvNumeric,
+									 intVal((Integer *) subcmd->def));
 				}
 				break;
 
 			case AT_SetOptions:
 			case AT_ResetOptions:
-				subcmds = lappend(subcmds, new_object_object(
-															 deparse_ColumnSetOptions(subcmd)));
+				deparse_ColumnSetOptions_ToJsonb(state, subcmd);
 				break;
 
 			case AT_SetStorage:
 				Assert(IsA(subcmd->def, String));
-				tmp_obj = new_objtree_VA("ALTER COLUMN %{column}I SET STORAGE %{storage}s", 3,
-										"type", ObjTypeString, "set storage",
-										"column", ObjTypeString, subcmd->name,
-										"storage", ObjTypeString,
-										strVal((String *) subcmd->def));
-				subcmds = lappend(subcmds, new_object_object(tmp_obj));
+				new_jsonb_VA(state,
+							 "ALTER COLUMN %{column}I SET STORAGE %{storage}s", false, 3,
+							 "type", jbvString, "set storage",
+							 "column", jbvString, subcmd->name,
+							 "storage", jbvString,
+							 strVal((String *) subcmd->def));
 				break;
 
 			case AT_SetCompression:
 				Assert(IsA(subcmd->def, String));
-				tmp_obj = new_objtree_VA("ALTER COLUMN %{column}I SET COMPRESSION %{compression_method}s", 3,
-										"type", ObjTypeString, "set compression",
-										"column", ObjTypeString, subcmd->name,
-										"compression_method", ObjTypeString,
-										strVal((String *) subcmd->def));
-				subcmds = lappend(subcmds, new_object_object(tmp_obj));
+				new_jsonb_VA(state,
+							 "ALTER COLUMN %{column}I SET COMPRESSION %{compression_method}s", false, 3,
+							 "type", jbvString, "set compression",
+							 "column", jbvString, subcmd->name,
+							 "compression_method", jbvString,
+							 strVal((String *) subcmd->def));
 				break;
 
 			case AT_DropColumn:
-				tmp_obj = new_objtree_VA("DROP %{objtype}s %{if_exists}s %{column}I", 4,
-										"objtype", ObjTypeString, "COLUMN",
-										"type", ObjTypeString, "drop column",
-										"if_exists", ObjTypeString,
-										subcmd->missing_ok ? "IF EXISTS" : "",
-										"column", ObjTypeString, subcmd->name);
-				tmp_obj2 = new_objtree("CASCADE");
-				if (subcmd->behavior != DROP_CASCADE)
-					append_not_present(tmp_obj2, NULL);
-				append_object_object(tmp_obj, "%{cascade}s", tmp_obj2);
+				pushJsonbValue(&state, WJB_BEGIN_OBJECT, NULL);
+				new_jsonb_VA(state,
+							 "DROP %{objtype}s %{if_exists}s %{column}I %{cascade}s", true, 4,
+							 "objtype", jbvString, "COLUMN",
+							 "type", jbvString, "drop column",
+							 "if_exists", jbvString,
+							 subcmd->missing_ok ? "IF EXISTS" : "",
+							 "column", jbvString, subcmd->name);
+
+				if (subcmd->behavior == DROP_CASCADE)
+					new_jsonb_VA(state, NULL, true, 1, "cascade", jbvString, "CASCADE");
+				else
+				{
+					insert_jsonb_key(state, "cascade");
+					insert_not_present_obj(state, "CASCADE");
+				}
+
+				pushJsonbValue(&state, WJB_END_OBJECT, NULL);
 
-				subcmds = lappend(subcmds, new_object_object(tmp_obj));
 				break;
 
 			case AT_AddIndex:
@@ -2339,17 +2261,16 @@ deparse_AlterRelation(CollectedCommand *cmd, ddl_deparse_context *context)
 					constrOid = get_relation_constraint_oid(
 															cmd->d.alterTable.objectId, idxname, false);
 
-					tmp_obj = new_objtree_VA("ADD CONSTRAINT %{name}I %{definition}s", 3,
-											"type", ObjTypeString, "add constraint",
-											"name", ObjTypeString, idxname,
-											"definition", ObjTypeString,
-											pg_get_constraintdef_string(constrOid));
-					subcmds = lappend(subcmds, new_object_object(tmp_obj));
+					new_jsonb_VA(state,
+								 "ADD CONSTRAINT %{name}I %{definition}s", false, 3,
+								 "type", jbvString, "add constraint",
+								 "name", jbvString, idxname,
+								 "definition", jbvString,
+								 pg_get_constraintdef_string(constrOid));
 
 					relation_close(idx, AccessShareLock);
 				}
 				break;
-
 			case AT_AddConstraint:
 				{
 					/* XXX need to set the "recurse" bit somewhere? */
@@ -2389,12 +2310,12 @@ deparse_AlterRelation(CollectedCommand *cmd, ddl_deparse_context *context)
 						}
 					}
 
-					tmp_obj = new_objtree_VA("ADD CONSTRAINT %{name}I %{definition}s", 3,
-											"type", ObjTypeString, "add constraint",
-											"name", ObjTypeString, get_constraint_name(constrOid),
-											"definition", ObjTypeString,
-											pg_get_constraintdef_string(constrOid));
-					subcmds = lappend(subcmds, new_object_object(tmp_obj));
+					new_jsonb_VA(state,
+								 "ADD CONSTRAINT %{name}I %{definition}s", false, 3,
+								 "type", jbvString, "add constraint",
+								 "name", jbvString, get_constraint_name(constrOid),
+								 "definition", jbvString,
+								 pg_get_constraintdef_string(constrOid));
 				}
 				break;
 
@@ -2408,34 +2329,34 @@ deparse_AlterRelation(CollectedCommand *cmd, ddl_deparse_context *context)
 						break;
 
 					Assert(IsA(c, Constraint));
-					tmp_obj = new_objtree_VA("ALTER CONSTRAINT %{name}I %{deferrable}s %{init_deferred}s", 4,
-											"type", ObjTypeString, "alter constraint",
-											"name", ObjTypeString, get_constraint_name(constrOid),
-											"deferrable", ObjTypeString,
-											c->deferrable ? "DEFERRABLE" : "NOT DEFERRABLE",
-											"init_deferred", ObjTypeString,
-											c->initdeferred ? "INITIALLY DEFERRED" : "INITIALLY IMMEDIATE");
-
-					subcmds = lappend(subcmds, new_object_object(tmp_obj));
+
+					new_jsonb_VA(state,
+								 "ALTER CONSTRAINT %{name}I %{deferrable}s %{init_deferred}s", false, 4,
+								 "type", jbvString, "alter constraint",
+								 "name", jbvString, get_constraint_name(constrOid),
+								 "deferrable", jbvString,
+								 c->deferrable ? "DEFERRABLE" : "NOT DEFERRABLE",
+								 "init_deferred", jbvString,
+								 c->initdeferred ? "INITIALLY DEFERRED" : "INITIALLY IMMEDIATE");
 				}
 				break;
 
 			case AT_ValidateConstraint:
-				tmp_obj = new_objtree_VA("VALIDATE CONSTRAINT %{constraint}I", 2,
-										"type", ObjTypeString, "validate constraint",
-										"constraint", ObjTypeString, subcmd->name);
-				subcmds = lappend(subcmds, new_object_object(tmp_obj));
+				new_jsonb_VA(state,
+							 "VALIDATE CONSTRAINT %{constraint}I", false, 2,
+							 "type", jbvString, "validate constraint",
+							 "constraint", jbvString, subcmd->name);
 				break;
 
 			case AT_DropConstraint:
-				tmp_obj = new_objtree_VA("DROP CONSTRAINT %{if_exists}s %{constraint}I %{cascade}s", 4,
-										"type", ObjTypeString, "drop constraint",
-										"if_exists", ObjTypeString,
-										subcmd->missing_ok ? "IF EXISTS" : "",
-										"constraint", ObjTypeString, subcmd->name,
-										"cascade", ObjTypeString,
-										subcmd->behavior == DROP_CASCADE ? "CASCADE" : "");
-				subcmds = lappend(subcmds, new_object_object(tmp_obj));
+				new_jsonb_VA(state,
+							 "DROP CONSTRAINT %{if_exists}s %{constraint}I %{cascade}s", false, 4,
+							 "type", jbvString, "drop constraint",
+							 "if_exists", jbvString,
+							 subcmd->missing_ok ? "IF EXISTS" : "",
+							 "constraint", jbvString, subcmd->name,
+							 "cascade", jbvString,
+							 subcmd->behavior == DROP_CASCADE ? "CASCADE" : "");
 				break;
 
 			case AT_AlterColumnType:
